<template>
  <q-modal
    :value="isActive"
    @hide="close"
  >
    <div
      class="q-pa-md"
      v-if="item"
    >
      <div class="q-title">Edit <b v-html="item.menu_name"/> menu item</div>
      <q-input
        v-model="record.menu_name"
        stack-label="Menu Name"
        inverted-light
        color="white"
        class="q-mt-md"
      />
      <q-checkbox
        v-model="isCollection"
        label="Is collection"
        class="q-mt-md"
      />
      <q-select
        v-if="isCollection"
        v-model="record.collection_id"
        stack-label="Collection"
        inverted-light
        color="white"
        :filter="availableCollections.length > 10"
        :options="availableCollections"
        class="q-mt-md"
      />
      <q-input
        v-if="!isCollection"
        v-model="record.sref"
        stack-label="Custom view code"
        inverted-light
        color="white"
        class="q-mt-md"
      />
      <div class="q-mt-md text-center">
        <q-btn
          color="green"
          :label="record.id ? 'Save' : 'Create'"
          @click="save"
        />
      </div>
    </div>
  </q-modal>
</template>

<script>
  import endpointsMixin from '../../../../mixins/endpointsMixin';

  export default {
    name: 'menuItemEditor',
    props: {
      item: Object,
      isActive: Boolean,
      hasChildren: Boolean,
    },
    mixins: [endpointsMixin],
    created() {
      this.loadCollections();
    },
    watch: {
      item(item) {
        if (item) {
          this.record = { ...(item) };
          this.isCollection = !!item.collection_id;
        }
      },
      isCollection(val) {
        if (!val) {
          this.record.collection_id = null;
        } else {
          this.record.sref = null;
        }
      },
    },
    data() {
      return {
        record: { ...(this.item) },

        availableCollections: [],

        isCollection: false,
      };
    },
    methods: {
      close() {
        this.$emit('close');
      },
      save() {
        this.saveMenuItem(this.record)
          .then(() => {
            this.$emit('close');
            this.$emit('saved');
          });
      },
      loadCollections() {
        this.fetchCollections()
          .then((results) => {
            this.availableCollections = results.map(({ collection_id: value }) => ({
              value,
              label: value,
            }));
          });
      },
    },
  };
</script>

<style scoped>

</style>
